﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=11.2
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
#End Region

Sub Process_Globals
	Private nid As Int = 1
	Private LastUpdateTime As Long
	Private lock As PhoneWakeState
End Sub

Sub Service_Create
	'Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	lock.PartialLock
End Sub

Sub Service_Start (StartingIntent As Intent)
	'Service.StartForeground(nid, CreateNotification("..."))
	'StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
	'PrezzoCambiato
	If Starter.RunService Then
		FetchPrice
	End If
End Sub

'Sub PrezzoCambiato
'	If DateTime.Now > LastUpdateTime + 10 * DateTime.TicksPerSecond Then
'		Dim n As Notification = CreateNotification($"Prezzo superiore a n "$)
'		n.Notify(nid)
'		LastUpdateTime = DateTime.Now
'	End If
'End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	'notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Initialize2(notification.IMPORTANCE_HIGH)
	notification.Icon = "icon"
	notification.SetInfo("Prezzo superiore a n ", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	lock.ReleasePartialLock
End Sub

Sub FetchPrice
	Log("Fetching price...")
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download("https://api.hotbit.io/api/v1/market.last?market=KIBA/USDT")
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		Log(j.GetString)
		Dim parser As JSONParser
		parser.Initialize(j.GetString)
		Dim root As Map = parser.NextObject
		Dim result As String = root.Get("result")
		'Label1.Text = result
		CallSubDelayed2(Main, "ShowPriceLabel", result)
		If result.As(Double) > 0.000026 Then
			Log($"Alert! ${result}"$)
			Starter.RunService = False
			CallSubDelayed2(Main, "SetButtonText", "Start Service")
			'timer1.Enabled = False
			' invia notifica
			Service.StartForeground(nid, CreateNotification(result))
			Return
		Else
			Log("pass...")
		End If
		LastUpdateTime = DateTime.Now
		StartServiceAt(Me, LastUpdateTime + 5 * DateTime.TicksPerSecond, True) ' After 3 seconds
	End If
	j.Release
End Sub